<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import sys</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">import time</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">from functools import wraps</td></tr><tr class="noCover"><td class="line"><a name="5">5</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">MAJOR &#61; 0</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">MINOR &#61; 1</td></tr><tr class="noCover"><td class="line"><a name="8">8</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">def pretty_function_with_args_str(func, args, kwargs):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">    return f&#39;{func.__module__}:{func.__name__}({pretty_args(args, kwargs)})&#39;</td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="13">13</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">def pretty_args(args, kwargs):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">    strings &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="16">16</a></td><td class="hits">1</td><td class="code">    if args:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">        strings.extend([repr(arg) for arg in args])</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="18">18</a></td><td class="hits">1</td><td class="code">    if kwargs:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">        strings.extend([f&#39;{key}&#61;{repr(val)}&#39; for key, val in kwargs.items()])</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">    return &#39;, &#39;.join(strings)</td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="23">23</a></td><td class="hits">1</td><td class="code">def pretty_function_no_args_str(func):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">    return f&#39;{func.__module__}:{func.__name__}(...)&#39;</td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">def trace(logger: logging.Logger, capture_args&#61;True):</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Decorator to trace the execution time of a Python function or method.</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code">    Uses INFO log level for logging the traced function&#39;s &#34;exec time&#34;.</td></tr><tr class="noCover"><td class="line"><a name="31">31</a></td><td class="hits"></td><td class="code">    Also will log the traced function&#39;s entry and exit at DEBUG log level.</td></tr><tr class="noCover"><td class="line"><a name="32">32</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code">        logger (logging.Logger): The logger instance for the function&#39;s module.</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code">        capture_args (bool, optional): When tracing the function, capture the </td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">            arguments provided to the function and add them to the log message.</td></tr><tr class="noCover"><td class="line"><a name="37">37</a></td><td class="hits"></td><td class="code">            Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code">    Example:</td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code">    First, get the logger for your Python module.</td></tr><tr class="noCover"><td class="line"><a name="42">42</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code">        import logging</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">        logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="46">46</a></td><td class="hits"></td><td class="code">    Then, use the trace_time decorator with that logger as the argument.</td></tr><tr class="noCover"><td class="line"><a name="47">47</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">        import uologging</td></tr><tr class="noCover"><td class="line"><a name="49">49</a></td><td class="hits"></td><td class="code">        &#64;uologging.trace(logger)</td></tr><tr class="noCover"><td class="line"><a name="50">50</a></td><td class="hits"></td><td class="code">        def my_slow_function():</td></tr><tr class="noCover"><td class="line"><a name="51">51</a></td><td class="hits"></td><td class="code">            import time</td></tr><tr class="noCover"><td class="line"><a name="52">52</a></td><td class="hits"></td><td class="code">            time.sleep(1)</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code">        my_slow_function()</td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="55">55</a></td><td class="hits">1</td><td class="code">    def _trace_time(func):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">        def log_info(msg):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">            if sys.version_info[MAJOR] &gt;&#61; 3 and sys.version_info[MINOR] &gt;&#61; 8:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">                logger.info(msg, stacklevel&#61;3)</td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="60">60</a></td><td class="hits">0</td><td class="code">                logger.info(msg)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="61">61</a></td><td class="hits">1</td><td class="code">        def log_debug(msg):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="62">62</a></td><td class="hits">1</td><td class="code">            if sys.version_info[MAJOR] &gt;&#61; 3 and sys.version_info[MINOR] &gt;&#61; 8:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">                logger.info(msg, stacklevel&#61;3)</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="65">65</a></td><td class="hits">0</td><td class="code">                logger.info(msg)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="66">66</a></td><td class="hits">1</td><td class="code">        &#64;wraps(func)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="67">67</a></td><td class="hits">1</td><td class="code">        def timed(*args, **kwargs):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="68">68</a></td><td class="hits">1</td><td class="code">            if capture_args:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="69">69</a></td><td class="hits">1</td><td class="code">                function_str &#61; pretty_function_with_args_str(func, args, kwargs)</td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">                function_str &#61; pretty_function_no_args_str(func)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">            log_debug(f&#39;Starting: {function_str}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">            start &#61; time.time()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="74">74</a></td><td class="hits">1</td><td class="code">            result &#61; func(*args, **kwargs)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="75">75</a></td><td class="hits">1</td><td class="code">            end &#61; time.time()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">            log_debug(f&#39;Finished: {function_str}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="77">77</a></td><td class="hits">1</td><td class="code">            log_info(f&#39;{function_str} exec time: {end - start:.2f} sec&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="78">78</a></td><td class="hits">1</td><td class="code">            return result</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="79">79</a></td><td class="hits">1</td><td class="code">        return timed</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">    return _trace_time</td></tr>