<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import logging.handlers</td></tr><tr class="noCover"><td class="line"><a name="3">3</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">_logging_format &#61; logging.Formatter(</td></tr><tr class="noCover"><td class="line"><a name="5">5</a></td><td class="hits"></td><td class="code">    &#39;%(asctime)s %(levelname)-8s  %(message)s [%(pathname)s:%(lineno)d]&#39;,</td></tr><tr class="noCover"><td class="line"><a name="6">6</a></td><td class="hits"></td><td class="code">    &#39;%Y-%m-%d %H:%M:%S&#39;)</td></tr><tr class="noCover"><td class="line"><a name="7">7</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="8">8</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="9">9</a></td><td class="hits">1</td><td class="code">initialized_syslog_packages &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">def init_syslog(name:str &#61; None):</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Setup logging to be output to syslog (via /dev/log).</td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="13">13</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="14">14</a></td><td class="hits"></td><td class="code">        name (str, optional): Which logger to configure. Default to root logger.</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code">    Example:</td></tr><tr class="noCover"><td class="line"><a name="17">17</a></td><td class="hits"></td><td class="code">        Call this method.</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; import uologging</td></tr><tr class="noCover"><td class="line"><a name="19">19</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; uologging.init_syslog()</td></tr><tr class="noCover"><td class="line"><a name="20">20</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code">        Then use the Python logging package in each of your package&#39;s modules.</td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; import logging</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code">        We use a hardcoded str here to enable this doctest:</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger &#61; logging.getLogger(&#39;examplepkg.just.testing&#39;)</td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger.critical(&#39;Just kidding, this is a test!&#39;)    </td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code">    global initialized_syslog_packages</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">    if name not in initialized_syslog_packages:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">        syslog_handler &#61; logging.handlers.SysLogHandler(address&#61;&#39;/dev/log&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">        _add_log_handler_with_formatter(syslog_handler, name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">        initialized_syslog_packages.append(name)</td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="36">36</a></td><td class="hits">1</td><td class="code">initialized_console_packages &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">def init_console(name:str &#61; None):</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Setup logging to be output to the console.</td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code">        name (str, optional): Which logger to configure. Default to root logger.</td></tr><tr class="noCover"><td class="line"><a name="42">42</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code">    Example:</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">        Call this method.</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; import uologging</td></tr><tr class="noCover"><td class="line"><a name="46">46</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; uologging.init_console()</td></tr><tr class="noCover"><td class="line"><a name="47">47</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">        Then use the Python logging package in each of your package&#39;s modules.</td></tr><tr class="noCover"><td class="line"><a name="49">49</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; import logging</td></tr><tr class="noCover"><td class="line"><a name="50">50</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="51">51</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="52">52</a></td><td class="hits"></td><td class="code">        We use a hardcoded str here to enable doctest:</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger &#61; logging.getLogger(&#39;examplepkg.just.testing&#39;)</td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; logger.critical(&#39;Just kidding, this is a test!&#39;)</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code">    global initialized_console_packages</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">    if name not in initialized_console_packages:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">        console_handler &#61; logging.StreamHandler()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="59">59</a></td><td class="hits">1</td><td class="code">        _add_log_handler_with_formatter(console_handler, name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="60">60</a></td><td class="hits">1</td><td class="code">        initialized_console_packages.append(name)</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">def set_verbosity(verbosity_flag: int, name:str &#61; None):</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Set the logging verbosity for a logger.</td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">        verbosity_flag (int): Higher number means more logging. Choices are [0,2]. </td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">            Default is 0. Default will captures WARNING, ERROR, and CRITICAL logs.</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code">            Provide 1 to also capture INFO logs. Provide 2 to also capture DEBUG logs.</td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code">        name (str, optional): Which logger to configure. Default to root logger.</td></tr><tr class="noCover"><td class="line"><a name="71">71</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">    logger &#61; logging.getLogger(name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">    if verbosity_flag &#61;&#61; 1:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="74">74</a></td><td class="hits">1</td><td class="code">        logger.setLevel(logging.INFO)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="75">75</a></td><td class="hits">1</td><td class="code">    elif verbosity_flag &gt;&#61; 2:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">        logger.setLevel(logging.DEBUG)</td></tr><tr class="noCover"><td class="line"><a name="77">77</a></td><td class="hits"></td><td class="code">    else:  # Default to WARNING, following Python logging standards</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="78">78</a></td><td class="hits">1</td><td class="code">        logger.setLevel(logging.WARNING)</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="80">80</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="81">81</a></td><td class="hits">1</td><td class="code">def _add_log_handler_with_formatter(handler: logging.Handler, name:str &#61; None):</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Add a handler to a logger.</td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="84">84</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code">        handler (logging.Handler): A logging handler.</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code">        name (str, optional): Which logger to configure. Default to root logger.</td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="88">88</a></td><td class="hits">1</td><td class="code">    handler.setFormatter(_logging_format)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="89">89</a></td><td class="hits">1</td><td class="code">    logger &#61; logging.getLogger(name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">    logger.addHandler(handler)</td></tr>